// ==UserScript==
// @name         LILY
// @namespace    https://code.fleshless.org/mute
// @version      0.0.1
// @description  Lily's Integrated Logic Yoke
// @grant        none
// @author       Mute
// @require      https://code.fleshless.org/mute/LILY/raw/branch/mistress/bcmodsdk-1.2.0.mjs
// @match        https://bondageprojects.elementfx.com/*
// @match        https://www.bondageprojects.elementfx.com/*
// @match        https://bondage-europe.com/*
// @match        https://www.bondage-europe.com/*
// @match        http://localhost:*/*
// ==/UserScript==
(function() {
	'use strict';
	const W = /** @type {Window & typeof globalThis & {bcModSdk: import('bondage-club-mod-sdk').ModSDKGlobalAPI}} */ (window)
	const SDK = W.bcModSdk.registerMod({name: GM_info.script.name, fullName: GM_info.script.description ?? '', version: GM_info.script.version, repository: 'finger://your.mom'})
	/** @type {LILY.Utils} */ const U = {remove_hook: undefined,
		true(f) {f(); return true},
		with: (v, f) => f(v),
		send: f => f() && U.true(() => void W.ChatRoomCharacterUpdate(W.Player)),
	}
	/** @type {LILY.Box} */ const Box = {
		enable(item) { if (item === undefined) return false // TODO Okay, we need to be more clever here. The light should be above the box itself
			return U.with(item.Property, ip => typeof ip?.OverridePriority === 'object' && (ip.OverridePriority['Light'] = 41) > 0)
		},
		disable(item) { return item === undefined ? false : U.with(item.Property ??= {}, ip => U.with(ip.OverridePriority ??= {}, op =>
			typeof op === 'number' ? Boolean(ip.OverridePriority = {Lock: op, Unit: op}) : ((op['Light'] = 0) < 1)
		))},
		on: () => U.with(Box.item, i => U.send(() => Box.enable(i))),
		off: () => U.with(Box.item, i => U.send(() => Box.disable(i))),
		get item() {return U.with(W.InventoryGet(W.Player, 'ItemNeckAccessories'), item => item?.Craft?.Name === 'Lily\'s voicebox' ? item : undefined)},
		get enabled() {return U.with(Box.item, i => i !== undefined && U.with(i?.Property?.OverridePriority, op => typeof op !== 'object' || !Object.hasOwn(op, 'Light') || (op['Light'] ?? 1) > 0))}, // TODO check if the light is above the box
	}
	/** @type {LILY.Eyes} */ const Eyes = {timeout: undefined, zones: ['ItemHead', 'Mask'],
		rgb: [
			'#990000', '#990f00', '#991f00', '#992e00', '#993d00', '#994d00', '#995c00', '#996b00', '#997a00', '#998a00',
			'#999900', '#8a9900', '#7a9900', '#6b9900', '#5c9900', '#4d9900', '#3d9900', '#2e9900', '#1f9900', '#0f9900',
			'#009900', '#00990f', '#00991f', '#00992e', '#00993d', '#00994d', '#00995c', '#00996b', '#00997a', '#00998a',
			'#009999', '#008a99', '#007a99', '#006b99', '#005c99', '#004d99', '#003d99', '#002e99', '#001f99', '#000f99',
			'#000099', '#0f0099', '#1f0099', '#2e0099', '#3d0099', '#4d0099', '#5c0099', '#6b0099', '#7a0099', '#8a0099',
			'#990099', '#99008a', '#99007a', '#99006b', '#99005c', '#99004d', '#99003d', '#99002e', '#99001f', '#99000f',
		],
		craft: {Item: 'AnimeLenses', Name: 'Akihabara souvenir', Description: 'you will never be the same uwu', Color: '#FFFFFF,Default,#FFFFFF,Default', Property: 'Thick', Lock: '', Private: true, ItemProperty: {}, Type: null, TypeRecord: null, MemberNumber: 71_240, MemberName: 'Mute'},
		set_rgb: (item, n) => U.true(() => item.Color = [Eyes.rgb[n] ?? 'Default', 'Default', Eyes.rgb[n] ?? 'Default', 'Default']),
		next_rgb: () => Eyes.check('ItemHead') === undefined && U.with(Eyes.check('Mask'), i => i !== undefined && U.with(Eyes.rgb.indexOf(i.Color?.[0] ?? Eyes.rgb[0] ?? '') + 1, n => Eyes.set_rgb(i, n))),
		roll_rgb: () => Eyes.next_rgb() && void W.ChatRoomCharacterItemUpdate(W.Player, 'Mask'),
		start: () => Eyes.check('Mask') !== undefined && Eyes.timeout === undefined && Boolean(Eyes.timeout = setInterval(Eyes.roll_rgb, 1000)),
		stop: () => Eyes.check('Mask') !== undefined && Eyes.timeout !== undefined && U.true(() => Eyes.timeout = void clearInterval(Eyes.timeout)),
		dim: () => U.send(() => Eyes.check('ItemHead') === undefined && U.true(() => W.InventoryWear(W.Player, 'AnimeLenses', 'ItemHead', ['#FFFFFF', 'Default', '#FFFFFF', 'Default'], undefined, 71_240, Eyes.craft))),
		clear: () => U.send(() => Eyes.check('ItemHead') !== undefined && U.true(() => void W.InventoryRemove(W.Player, 'ItemHead'))),
		check: zone => U.with(Eyes.item, item => item?.Asset.Group.Name === zone ? item : undefined),
		get item() {return Eyes.zones.map(z => W.InventoryGet(W.Player, z)).find(item => item?.Asset.Name === 'AnimeLenses') ?? undefined},
	}
	/** @type {LILY.Belt} */ const Belt = {users: [119_643, 154_662], admins: [71_240, 67_994],
		cli: {'#LILY': {
			status: _ => '200 OK',
			box: {on: Box.on, off: Box.off},
			eyes: {start: Eyes.start, stop: Eyes.stop, dim: Eyes.dim, clear: Eyes.clear},
		}},
		/** @type {LILY.Belt['is_cb']} */ is_cb: s => typeof s === 'function',
		run(tokens) { /** @type {string | undefined} */ let t, /** @type {LILY.Commands | LILY.CommandCB} */ cmd = Belt.cli
			while ((t = tokens.shift()) !== undefined) if (U.with(cmd[t], next => next !== undefined && Belt.is_cb(cmd = next))) break // eslint-disable-line @typescript-eslint/no-loop-func
			if (!Belt.is_cb(cmd)) return t === undefined ? `subcommands: [${Object.keys(cmd).join(', ')}]` : `unknown token ${t}`
			return U.with(cmd(...tokens), r => typeof r === 'boolean' ? (r ? 'success' : 'fail') : String(r))
		},
		receive(data) { if (data.Sender === undefined) return undefined
			W.ChatRoomSendLocal(`<span style="color: #666">${data.Content}</span>`)
			return void W.ChatRoomSendWhisper(data.Sender, `LILY: ${Belt.admins.includes(data.Sender) ? Belt.run(data.Content.split(' ')) : 'access denied'}`)
		},
	}
	/** @type {(text: string) => undefined} */ const unload = text => U.true(SDK.unload) && void console.debug(`LILY: ${text}, unloading the mod`)
	const load_after_login = () => {
		if (U.remove_hook !== undefined) {U.remove_hook?.(); U.remove_hook = undefined}
		if (W.Player.MemberNumber === undefined) return void unload('member not identified')
		if (!Belt.users.includes(W.Player.MemberNumber)) return void unload('member not eligible for loading')
		SDK.hookFunction('SpeechTransformGagGarble', 0, ([text]) => text) // disable garbling
		SDK.hookFunction('ChatRoomSendChatMessage', 0, (na, n) => Box.enabled || na[0].startsWith('(') ? n(na) : !U.true(() => void W.ChatRoomSendLocal('<span style="color: red">You try to talk, but nothing comes out.</span>')))
		W.ChatRoomRegisterMessageHandler({Priority: -169, Description: 'LILY', Callback: data => data.Type === 'Whisper' && data.Content.startsWith('#LILY') && U.true(() => void Belt.receive(data))})
		console.debug(`LILY: eligible member detected, loaded version ${GM_info.script.version}`)
	}
	U.remove_hook = SDK.hookFunction('AsylumGGTSSAddItems', 0, (na, n) => U.true(load_after_login) && void n(na))
})()
